summaryrefslogtreecommitdiff
path: root/oh-my-zsh/plugins/rake-fast/rake-fast.plugin.zsh
diff options
context:
space:
mode:
Diffstat (limited to 'oh-my-zsh/plugins/rake-fast/rake-fast.plugin.zsh')
-rw-r--r--oh-my-zsh/plugins/rake-fast/rake-fast.plugin.zsh43
1 files changed, 43 insertions, 0 deletions
diff --git a/oh-my-zsh/plugins/rake-fast/rake-fast.plugin.zsh b/oh-my-zsh/plugins/rake-fast/rake-fast.plugin.zsh
new file mode 100644
index 0000000..19dab15
--- /dev/null
+++ b/oh-my-zsh/plugins/rake-fast/rake-fast.plugin.zsh
@@ -0,0 +1,43 @@
+_rake_does_task_list_need_generating () {
+ [[ ! -f .rake_tasks ]] || [[ Rakefile -nt .rake_tasks ]] || { _is_rails_app && _tasks_changed }
+}
+
+_is_rails_app () {
+ [[ -e "bin/rails" ]] || [[ -e "script/rails" ]]
+}
+
+_tasks_changed () {
+ local -a files
+ files=(lib/tasks lib/tasks/**/*(N))
+
+ for file in $files; do
+ if [[ "$file" -nt .rake_tasks ]]; then
+ return 0
+ fi
+ done
+
+ return 1
+}
+
+_rake_generate () {
+ rake --silent --tasks | cut -d " " -f 2 | sed 's/\[.*\]//g' > .rake_tasks
+}
+
+_rake () {
+ if [[ -f Rakefile ]]; then
+ if _rake_does_task_list_need_generating; then
+ echo "\nGenerating .rake_tasks..." >&2
+ _rake_generate
+ fi
+ compadd $(cat .rake_tasks)
+ fi
+}
+compdef _rake rake
+
+rake_refresh () {
+ [[ -f .rake_tasks ]] && rm -f .rake_tasks
+
+ echo "Generating .rake_tasks..." >&2
+ _rake_generate
+ cat .rake_tasks
+}